import { Component, Injector } from '@angular/core';
import { NativeInputComponent } from '../../_abstract/native-input.component';
import { Router, ActivatedRoute } from '@angular/router';
import { IOption, ILink } from '../../../models/field.model';
import { FriendlyValidationErrorsService } from './../../../services/friendly-validation-errors.service';


@Component({
	selector: 'app-select',
	templateUrl: './clr-select.component.html',
	styleUrls: ['./clr-select.component.scss']
})
export class ClrSelectComponent extends NativeInputComponent {

	exposeMetaInTemplate: string[] = ['label', 'options', 'link'];

	label: string;
	options: IOption[];
	link: ILink;

	readonly componentName = 'SelectComponent'; // For AOT compatibility, as class names don't survive minification

	// TODO: Emit event to parant dynaform to do routing - then all form components will be able to use it
	// It's cleaner
	constructor(
		private router: Router,
		private route: ActivatedRoute,
		protected valErrsService: FriendlyValidationErrorsService
	) {
		super(valErrsService);
	}

	navigate(field: HTMLSelectElement) {
		const base = Array.isArray(this.meta.link.route) ? this.meta.link.route : [this.meta.link.route];
		const destination = [...base, field.options[field.selectedIndex].value];
		this.router.navigate(destination, { relativeTo: this.route });
	}

}
